<?php if (session_id() == "") session_start(); ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
	<title>BlackBox</title>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
	<meta name="description" content="BlackBox is a Adobe Flash based chat program" />
	<meta name="revised" content="Gabriel Mariani, 3/20/2008" />
	
	<style>
		*, 
		*:before, 
		*:after {
			box-sizing: border-box;
		}
		
		html,
		body {
			height:100%;
		}
		
		ul, ol {
			margin: 0 0 20px 20px;
			padding: 0px;
		}
		
		a {
			color: #c7532d;
		}
		
		/*a:link,
		a:visited,
		a:active {
			text-decoration: none;
			color: #999999;
		}
		a:hover {
			text-decoration: none;
			color: #148BB8;
		}*/

		.style1 {
			font-family: Arial, Helvetica, sans-serif;
			font-size: x-small;
			color: #999999;
		}

		.style2 {
			color: #666666;
			font-family: Arial, Helvetica, sans-serif;
			font-weight: bold;
		}
		.style3 {
			font-size: 12px;
			font-family: Arial, Helvetica, sans-serif;
			color: #666666;
		}
		
		h1 a {
			text-decoration: none;
		}
		
		h3 a {
			text-decoration: none;
			display:inline-block;
			width: 100%;
		}
		
		body {
			margin: 0 auto;
			max-width: 1000px;
			width:100%;
			padding:25px;
			background-color: #fff;
		    font: 11px/16px Verdana, Tahoma;
			color: #363636;
		}
		
		main {
			padding-bottom:30px;
		}
		
		#wrapper {
			text-align: center;
			padding: 30px;
		}
		
		#wrapper object {
			box-shadow: 2px 2px 20px 5px rgba(0,0,0,0.3);
		}
		
		div.logo {
			float: left;
			background-repeat: no-repeat;
			height: 128px;
			width: 165px;
		}
		
		div.details {
			padding: 20px 0 0 0;
		}
		
		.wp-caption {
			border: 1px solid #ddd;
			text-align: center;
			background-color: #f3f3f3;
			padding-top: 4px;
			margin: 10px;
		}
		
		.wp-caption p.wp-caption-text {
			font-size: 11px;
			line-height: 17px;
			padding: 0 4px 5px;
			margin: 0;
		}
		
		.aligncenter, 
		div.aligncenter {
			display: block;
			margin-left: auto;
			margin-right: auto;
		}
	</style>
</head>
<body>
	<main>
		<h1><a href="http://mariani.life/projects/blackbox/" rel="bookmark" title="BlackBox - Flash Secure Login">BlackBox - Flash Secure Login</a></h1>

		<div>
			<div class="logo" style="background-image: url(./assets/img/BlackBox_128.png);"></div>
			<div class="details">
				<div>Version 0.1, Updated March 20, 2008</div>
				<ul class="stats">
					<li><strong>Compatibility:</strong> ActionScript 3.0</li>
					<li><strong>File Size:</strong> About -Kb</li>
					<li><a href='#changelog'>Change Log</a></li>
				</ul>
			</div>
		</div>
		<div class="clear"></div>

		<div id="wrapper">
			<h3><a title="BlackBox" class="external text" href="blackbox_0.1.zip">Download Now (0.1)</a></h3>
			<div id="flashcontent">
				<p>
					<strong>You need to upgrade your Flash Player</strong><br>
					This site requires atleast version 9.
				</p>
			</div>
		</div>

		<h3>Description</h3>
		<strong>BlackBox</strong> is a Flash-based login application. We built this much for the same reasons Comet was. We didn't have anyway of doing a secure (read SSL) connection so we made our own next best thing. Whats funny is that in the end, the method we "ingeniously" came up with is almost the exact same method used with POP servers to send email.
		
		<p>This is how the login works:</p>
		<ol>
			<li>Flash client first intiates a handshake by sending a random number (clientRand) to the server.</li>
			<li>The server generates it's own random number (serverRand) and grabs the difference (randDiff) between the two numbers.</li>
			<li>The difference (randDiff) is saved to the database for the user logging in and the server's random number is sent back to the client.</li>
			<li>The client calculates the same difference (randDiff) and then sends the username and an MD5 of the password salted with the difference (randDiff).</li>
			<li>The server then uses the username to pull randDiff and password for the user. Creates a hash salted with randDiff and compares what the client sent.</li>
			<li>If all is well, it returns success and the client continues onto to the secure page.</li>
		</ol>
		
		<p>This is an old project that's basically a poor mans Diffe-Hellman key exchange done well before I knew what Diffie-Hellman even was. The username is <strong>demo</strong> and the password is <strong>password</strong>. Enjoy!</p>

		<a href="http://mariani.life/" target="_blank">BlackBox by Gabriel Mariani</a>
	</main>
	
	<script src="./assets/js/swfobject.js"></script> 
	<script type="text/javascript">
		var flashvars = {};
		flashvars.lastpage = 'secret.php';
		var params = {};
		params.bgcolor = "#000000";
		var attributes = {};
		attributes.id = "blackbox";
		swfobject.embedSWF("./assets/swf/login.swf?lastpage=secret.php", "flashcontent", "200", "100", "9.0.0", "./assets/swf/expressInstall.swf", flashvars, params, attributes);
	</script>
</body>
</html>